#!/usr/bin/env python

"""
An import node implementation taken from libxml2dom.Node for use with libxml2macro.
"""

from libxml2dom.macrolib.macrolib import *
import xml.dom

def importNode(x2_self, x2_node, deep):

    if x2_node.nodeType == xml.dom.Node.ELEMENT_NODE:
        x2_imported_element = x2_self.ownerDocument.createElementNS(x2_node.namespaceURI, x2_node.tagName)
        for x2_value in x2_node.attributes.values():
            x2_imported_element.setAttributeNS(x2_value.namespaceURI, x2_value.nodeName, x2_value.nodeValue)

        if deep:
            for child in x2_node.childNodes:
                x2_imported_child = x2_self.importNode(child, deep)
                if x2_imported_child:
                    x2_imported_element.appendChild(x2_imported_child)

        return x2_imported_element

    elif x2_node.nodeType == xml.dom.Node.TEXT_NODE:
        return x2_self.ownerDocument.createTextNode(x2_node.nodeValue)

    elif x2_node.nodeType == xml.dom.Node.ATTRIBUTE_NODE:
        return x2_self.ownerDocument.createAttributeNS(x2_node.namespaceURI, x2_node.name)

    elif x2_node.nodeType == xml.dom.Node.COMMENT_NODE:
        return x2_self.ownerDocument.createComment(x2_node.data)

    raise ValueError, x2_node.nodeType

# Special hack for the generated code.

Node_importNode = importNode

# vim: tabstop=4 expandtab shiftwidth=4
